from gamelib.game_base import Science


class ResearchArea(Science):
    SCIENCE_TYPE = 'research'


class Physics(ResearchArea):
    NAME = "Physics"


class Psychology(ResearchArea):
    NAME = "Psychology"


class MedicalExperiments(ResearchArea):
    NAME = "Medical Experiments"


class Meteorology(ResearchArea):
    NAME = "Meteorology"


class Biogenetics(ResearchArea):
    NAME = "Biogenetics"
    PREREQUISITES = (
        (MedicalExperiments, 2),
        )


class Oceanography(ResearchArea):
    NAME = "Oceanography"
    PREREQUISITES = (
        (Physics, 1),
        (Meteorology, 1),
        )


class Lasers(ResearchArea):
    NAME = "Lasers"
    PREREQUISITES = (
        (Physics, 2),
        )


class Fusion(ResearchArea):
    NAME = "Fusion"
    IMAGE_NAME = "hbomb"
    PREREQUISITES = (
        (Physics, 10),
        )


class Electrickery(ResearchArea):
    NAME = "Electrickery"
    PREREQUISITES = (
        (Physics, 1),
        )


class Rocketry(ResearchArea):
    NAME = "Rocketry"
    PREREQUISITES = (
        (Physics, 3),
        )


class Robotics(ResearchArea):
    NAME = "Robotics"
    PREREQUISITES = (
        (Electrickery, 3),
        )


class Space(ResearchArea):
    NAME = "SPAAAAAACE!"
    PREREQUISITES = (
        (Robotics, 1),
        (Rocketry, 2),
        )


class MarineBiology(ResearchArea):
    NAME = "Marine Biology"
    PREREQUISITES = (
        (Biogenetics, 2),
        (Oceanography, 2),
        )


class ArtificialIntelligence(ResearchArea):
    NAME = "Artificial Intelligence"
    PREREQUISITES = (
        (Robotics, 4),
        (Psychology, 2),
        )
